/*
 * Copyright 2023 peter.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package hk.quantr.qemulogpanel;

import java.io.File;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author peter
 */
public class ListErrorDialog extends javax.swing.JDialog {

	File database;
	ListErrorTableModel model = new ListErrorTableModel();
	public boolean process;
	public long sequence;

	/**
	 * Creates new form ListErrorDialog
	 */
	public ListErrorDialog(java.awt.Frame parent, boolean modal, File database) {
		super(parent, modal);
		this.database = database;

		initComponents();
		loadSetting();
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        fromTextField = new javax.swing.JFormattedTextField();
        jLabel3 = new javax.swing.JLabel();
        toTextField = new javax.swing.JFormattedTextField();
        jLabel4 = new javax.swing.JLabel();
        limitTextField = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jProgressBar1 = new javax.swing.JProgressBar();
        ignoreConsequenceCheckBox = new javax.swing.JCheckBox();
        clearTableCheckBox = new javax.swing.JCheckBox();
        listErrorButton = new javax.swing.JButton();
        jPanel7 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("List Error");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));

        jPanel6.setMaximumSize(new java.awt.Dimension(32767, 40));

        fromTextField.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        fromTextField.setText("0");
        fromTextField.setPreferredSize(new java.awt.Dimension(180, 24));
        jPanel6.add(fromTextField);

        jLabel3.setText("To");
        jPanel6.add(jLabel3);

        toTextField.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        toTextField.setText("200,000,000");
        toTextField.setPreferredSize(new java.awt.Dimension(180, 24));
        jPanel6.add(toTextField);

        jLabel4.setText("Limit");
        jPanel6.add(jLabel4);

        limitTextField.setText("1000");
        limitTextField.setPreferredSize(new java.awt.Dimension(80, 24));
        jPanel6.add(limitTextField);

        jPanel1.add(jPanel6);

        jPanel2.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.LINE_AXIS));

        jProgressBar1.setStringPainted(true);
        jPanel2.add(jProgressBar1);

        ignoreConsequenceCheckBox.setSelected(true);
        ignoreConsequenceCheckBox.setText("Ignore consequence");
        ignoreConsequenceCheckBox.setToolTipText("");
        ignoreConsequenceCheckBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                ignoreConsequenceCheckBoxItemStateChanged(evt);
            }
        });
        jPanel2.add(ignoreConsequenceCheckBox);

        clearTableCheckBox.setSelected(true);
        clearTableCheckBox.setText("Clear Table");
        clearTableCheckBox.setToolTipText("");
        clearTableCheckBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                clearTableCheckBoxItemStateChanged(evt);
            }
        });
        jPanel2.add(clearTableCheckBox);

        listErrorButton.setText("List Error");
        listErrorButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                listErrorButtonActionPerformed(evt);
            }
        });
        jPanel2.add(listErrorButton);

        jPanel1.add(jPanel2);

        jPanel7.setLayout(new java.awt.BorderLayout());

        jTable1.setModel(model);
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTable1MouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(jTable1);

        jPanel7.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel1.add(jPanel7);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        setBounds(0, 0, 828, 883);
    }// </editor-fold>//GEN-END:initComponents

    private void listErrorButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_listErrorButtonActionPerformed
		listErrorButton.setEnabled(false);
		if (clearTableCheckBox.isSelected()) {
			model.data.clear();
			model.fireTableDataChanged();
		}
		new Thread(new Runnable() {
			@Override
			public void run() {
				try {
					int pageSize = 10000;
					ArrayList<String> temp;
					if (clearTableCheckBox.isSelected()) {
						temp = new ArrayList();
					} else {
						temp = (ArrayList<String>) Setting.getInstance().listErrorTable.clone();
					}
					long sec = System.nanoTime();
					int from = Integer.parseInt(fromTextField.getText().replaceAll(",", "")) / pageSize;
					int to = Integer.parseInt(toTextField.getText().replaceAll(",", "")) / pageSize;
					int limit = Integer.parseInt(limitTextField.getText());
					jProgressBar1.setMaximum(to - from);

					Connection conn = MyTableModel.fileToConnection(database);

					int NO_OF_THREAD = Runtime.getRuntime().availableProcessors() - 1;
					ExecutorService executor = Executors.newFixedThreadPool(NO_OF_THREAD);

					Range[] ranges = Range.getRanges(from, to, NO_OF_THREAD);
					for (int tempX = 0; tempX < ranges.length; tempX++) {
						Range range = ranges[tempX];
						final int threadNo = tempX;
						executor.submit(new Thread() {
							@Override
							public void run() {
								long lastSequence = -1;

								MyTableModel tempModel = new MyTableModel();
								tempModel.pageSize = pageSize;

								outer:
								for (int i = range.start; i <= range.end; i++) {
									System.out.println("thread " + threadNo + " = " + i);
									if (!isVisible()) {
										return;
									}
									synchronized (jProgressBar1) {
										jProgressBar1.setValue(jProgressBar1.getValue() + 1);
										jProgressBar1.setString("Page " + jProgressBar1.getValue() + ", " + (System.nanoTime() - sec) / 1000000000 + " sec");
									}
									tempModel.pageNo = i;
									tempModel.loadQemuH2Database(conn);
									if (tempModel.matches.contains(false)) {
										for (int j = 0; j < tempModel.matches.size(); j++) {
											if (!tempModel.matches.get(j)) {
												int sequence = tempModel.pageSize * tempModel.pageNo + j;
												synchronized (temp) {
													if (!ignoreConsequenceCheckBox.isSelected()) {
														temp.add(String.valueOf(sequence));
														model.fireTableDataChanged();
													} else if (ignoreConsequenceCheckBox.isSelected()) {
														if (lastSequence != sequence - 1) {
															temp.add(String.valueOf(sequence));
														} else {
															temp.set(temp.size() - 1, temp.get(temp.size() - 1).split(" - ")[0] + " - " + sequence);
														}
														model.fireTableDataChanged();
													}

													if (temp.size() == limit) {
														break outer;
													}
												}

												lastSequence = sequence;
											}
										}
									}

									synchronized (Setting.getInstance()) {
										Setting.getInstance().listErrorTable = (ArrayList<String>) temp.clone();
										Setting.getInstance().save();
									}
								}

							}
						}
						);
					}
					executor.shutdown();
					try {
						executor.awaitTermination(Long.MAX_VALUE, TimeUnit.NANOSECONDS);
					} catch (InterruptedException ex) {
						Logger.getLogger(QemuLogPanel.class.getName()).log(Level.SEVERE, null, ex);
					}
					model.data = (ArrayList<String>) temp.clone();
					model.fireTableDataChanged();
					System.out.println("Time used: " + (System.nanoTime() - sec) / 1000000000 + " sec");
					listErrorButton.setEnabled(true);
				} catch (Exception ex) {
					ex.printStackTrace();
				}
			}
		}
		).start();
    }//GEN-LAST:event_listErrorButtonActionPerformed

    private void jTable1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseClicked
		if (evt.getClickCount() == 2) {
			sequence = Long.parseLong(((String) jTable1.getValueAt(jTable1.getSelectedRow(), 0)).split(" - ")[0]);
			process = true;
			saveSetting();
			setVisible(false);
		}
    }//GEN-LAST:event_jTable1MouseClicked

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
		saveSetting();
    }//GEN-LAST:event_formWindowClosing

    private void ignoreConsequenceCheckBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_ignoreConsequenceCheckBoxItemStateChanged
		long lastSequence = -1;
		ArrayList<String> temp = new ArrayList();
		for (String sequence : Setting.getInstance().listErrorTable) {
			if (!ignoreConsequenceCheckBox.isSelected()) {
				temp.add(String.valueOf(sequence));
				model.fireTableDataChanged();
			} else if (ignoreConsequenceCheckBox.isSelected()) {
				if (lastSequence != Long.parseLong(sequence.split(" - ")[0]) - 1) {
					temp.add(String.valueOf(sequence));
				} else {
					temp.set(temp.size() - 1, temp.get(temp.size() - 1).split(" - ")[0] + " - " + Long.parseLong(sequence.split(" - ")[0]));
				}
				model.fireTableDataChanged();
			}
			lastSequence = Long.parseLong(sequence.split(" - ")[0]);
		}
		model.data = (ArrayList<String>) temp.clone();
		model.fireTableDataChanged();
    }//GEN-LAST:event_ignoreConsequenceCheckBoxItemStateChanged

    private void clearTableCheckBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_clearTableCheckBoxItemStateChanged
		// TODO add your handling code here:
    }//GEN-LAST:event_clearTableCheckBoxItemStateChanged

	private void saveSetting() {
		Setting.getInstance().listErrorDialog_from = fromTextField.getText();
		Setting.getInstance().listErrorDialog_to = toTextField.getText();
		Setting.getInstance().listErrorDialog_limit = limitTextField.getText();
		Setting.getInstance().save();
	}

	private void loadSetting() {
		if (Setting.getInstance().listErrorDialog_from != null) {
			fromTextField.setText(Setting.getInstance().listErrorDialog_from);
		}
		if (Setting.getInstance().listErrorDialog_to != null) {
			toTextField.setText(Setting.getInstance().listErrorDialog_to);
		}
		if (Setting.getInstance().listErrorDialog_limit != null) {
			limitTextField.setText(Setting.getInstance().listErrorDialog_limit);
		}
		if (Setting.getInstance().listErrorTable != null) {
			model.data = (ArrayList<String>) Setting.getInstance().listErrorTable.clone();
		}
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox clearTableCheckBox;
    private javax.swing.JFormattedTextField fromTextField;
    private javax.swing.JCheckBox ignoreConsequenceCheckBox;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField limitTextField;
    private javax.swing.JButton listErrorButton;
    private javax.swing.JFormattedTextField toTextField;
    // End of variables declaration//GEN-END:variables
}
